#ifndef _RIGIDBODYTAG_H_
#define _RIGIDBODYTAG_H_

enum
{
	RIGID_BODY_DYNAMIC = 11003,
	RIGID_BODY_DYNAMIC_OFF = 0,
	RIGID_BODY_DYNAMIC_ON = 1,
	RIGID_BODY_DYNAMIC_GHOST = 2,

	RIGID_BODY_ENABLED = 11004,

	RIGID_BODY_HIERARCHY = 11006,
	RIGID_BODY_HIERARCHY_NONE = 0,
	RIGID_BODY_HIERARCHY_APPLY_TAG = 1,
	RIGID_BODY_HIERARCHY_COMPOUND_SHAPE = 2,

	RIGID_BODY_TRIGGER = 11007,
	RIGID_BODY_TRIGGER_IMMEDIATELY = 0,
	RIGID_BODY_TRIGGER_AT_PEAK = 2,
	RIGID_BODY_TRIGGER_ON_COLLISION = 3,
	RIGID_BODY_TRIGGER_XPRESSO = 4,

	RIGID_BODY_DYNAMIC_TRANSITION = 11008,

	RIGID_BODY_SPLIT_CACHE = 11009,
	RIGID_BODY_SPLIT_CACHE_OFF = 0,
	RIGID_BODY_SPLIT_CACHE_ON = 1,
	RIGID_BODY_SPLIT_CACHE_TOP_LEVEL = 2,
	RIGID_BODY_SPLIT_CACHE_SECOND_LEVEL = 3,

	RIGID_BODY_TRANSITION_TIME = 11010,

	RIGID_BODY_MASS_SWITCH = 11011,
	RIGID_BODY_MASS_SWITCH_DEFAULT = 0,
	RIGID_BODY_MASS_SWITCH_DENSITY = 1,
	RIGID_BODY_MASS_SWITCH_MASS = 2,
	
	RIGID_BODY_DENSITY = 11012,
	RIGID_BODY_MASS = 11013,
	
	RIGID_BODY_INERTIA_FACTOR = 11014,

	RIGID_BODY_USE_CENTER_OF_MASS = 11015,
	RIGID_BODY_CENTER_OF_MASS = 11016,

	RIGID_BODY_SELF_COLLISIONS = 11017,

	RIGID_BODY_SET_INITIAL_STATE = 11021,
	RIGID_BODY_CLEAR_INITIAL_STATE = 11022,

	RIGID_BODY_SHAPE_SIZE_INCREMENT = 11030,
	RIGID_BODY_SPECIFIC_MARGIN = 11031,
	RIGID_BODY_MARGIN = 11032,
	RIGID_BODY_SHAPE = 11033,
	RIGID_BODY_SHAPE_DEFAULT_MODYNAMICS = 0,
	RIGID_BODY_SHAPE_BOX = 1,
	RIGID_BODY_SHAPE_ELLIPSOID = 2,
	RIGID_BODY_SHAPE_NO_SHAPE = 3,
	RIGID_BODY_SHAPE_STATIC_MESH = 4,
	RIGID_BODY_SHAPE_CONVEX_HULL = 5,
	RIGID_BODY_SHAPE_KINETIC_MESH = 6,
	RIGID_BODY_SHAPE_CYLINDER_X = 7,
	RIGID_BODY_SHAPE_CYLINDER_Y = 8,
	RIGID_BODY_SHAPE_CYLINDER_Z = 9,
	RIGID_BODY_SHAPE_REFERENCE = 10,
	RIGID_BODY_SHAPE_DEFAULT = 11,

	RIGID_BODY_REFERENCE_SHAPE = 11038,

	RIGID_BODY_RESTITUTION = 11041,
	RIGID_BODY_FRICTION = 11042,
	RIGID_BODY_COLLISION_NOISE = 11043,

	RIGID_BODY_INITIAL_LINEAR_VELOCITY = 11051,
	RIGID_BODY_INITIAL_ANGULAR_VELOCITY = 11052,
	RIGID_BODY_LOCAL_INITIAL_VELOCITY = 11053,
	RIGID_BODY_SLEEPING_LINEAR_VELOCITY = 11054,
	RIGID_BODY_SLEEPING_ANGULAR_VELOCITY = 11055,
	RIGID_BODY_LINEAR_DAMPING = 11056,
	RIGID_BODY_ANGULAR_DAMPING = 11057,
	RIGID_BODY_USE_INITIAL_VELOCITY = 11058,

	RIGID_BODY_LINEAR_FOLLOW_STRENGTH = 11062,
	RIGID_BODY_ANGULAR_FOLLOW_STRENGTH = 11063,
	
	RIGID_BODY_FORCE_MODE = 11071,
	RIGID_BODY_FORCE_MODE_INCLUDE = 0,
	RIGID_BODY_FORCE_MODE_EXCLUDE = 1,
	RIGID_BODY_FORCE_INCLUDE_LIST = 11072,

	RIGID_BODY_ENABLED_SELECTION = 11081,
	RIGID_BODY_DYNAMIC_SELECTION = 11082,
	RIGID_BODY_ENABLED_FILL = 11083,
	RIGID_BODY_DYNAMIC_FILL = 11084,
	RIGID_BODY_TRIGGER_ON_COLLISION_VELOCITY = 11085,
	RIGID_BODY_SHOW = 11086,

	RIGID_BODY_GROUP_DYNAMICS = 11091,
	RIGID_BODY_GROUP_COLLISION = 11092,
	RIGID_BODY_GROUP_MASS = 11093,
	RIGID_BODY_GROUP_FORCE = 11094,
	RIGID_BODY_GROUP_DEACTIVATION = 11095,
	RIGID_BODY_GROUP_SOFT = 11097,
	RIGID_BODY_GROUP_CACHE = 11098,

	RIGID_BODY_MODYNAMICS = 11100,

	RIGID_BODY_SOFT = 11201,
	RIGID_BODY_SOFT_OFF = 0,
	RIGID_BODY_SOFT_ON = 1,
	RIGID_BODY_SOFT_OF_CLONES = 2,

	RIGID_BODY_SB_ACCURATE_SOLVER = 11202,
	RIGID_BODY_SB_MASS_MAP = 11203,
	RIGID_BODY_SB_KEEP_SHAPE = 11204,
	RIGID_BODY_SB_REST_STATE = 11205,

	RIGID_BODY_SB_SPRING_GROUP = 11210,

	RIGID_BODY_SB_STRUCTURAL = 11211,
	RIGID_BODY_SB_STRUCTURAL_MAP = 11212,
	RIGID_BODY_SB_STRUCTURAL_DAMPING = 11213,
	RIGID_BODY_SB_STRUCTURAL_DAMPING_MAP = 11214,
	RIGID_BODY_SB_ELASTIC_LIMIT = 11215,
	RIGID_BODY_SB_ELASTIC_LIMIT_MAP = 11216,

	RIGID_BODY_SB_SHEAR = 11221,
	RIGID_BODY_SB_SHEAR_MAP = 11222,
	RIGID_BODY_SB_SHEAR_DAMPING = 11223,
	RIGID_BODY_SB_SHEAR_DAMPING_MAP = 11224,

	RIGID_BODY_SB_FLEXION = 11231,
	RIGID_BODY_SB_FLEXION_MAP = 11232,
	RIGID_BODY_SB_FLEXION_DAMPING = 11233,
	RIGID_BODY_SB_FLEXION_DAMPING_MAP = 11234,
	RIGID_BODY_SB_FLEXION_ELASTIC_LIMIT = 11235,
	RIGID_BODY_SB_FLEXION_ELASTIC_LIMIT_MAP = 11236,

	RIGID_BODY_SB_REST_LENGTH = 11241,
	RIGID_BODY_SB_REST_LENGTH_MAP = 11242,

	RIGID_BODY_SB_TEAR_OUT_LENGTH = 11251,
	RIGID_BODY_SB_TEAR_OUT_LENGTH_MAP = 11252,

	RIGID_BODY_SB_CLONE_ROTATION_SEPARATOR = 11260,
	RIGID_BODY_SB_CLONE_ROTATION = 11261,
	RIGID_BODY_SB_CLONE_ROTATION_MAP = 11262,
	RIGID_BODY_SB_CLONE_ROTATION_DAMPING = 11263,
	RIGID_BODY_SB_CLONE_ROTATION_DAMPING_MAP = 11264,

	RIGID_BODY_SB_SHAPE_CONSERVATION_GROUP = 11270,

	RIGID_BODY_SB_SHAPE_CONSERVATION = 11271,
	RIGID_BODY_SB_SHAPE_CONSERVATION_MAP = 11272,
	RIGID_BODY_SB_SHAPE_VOLUME_CONSERVATION = 11273,
	RIGID_BODY_SB_SHAPE_CONSERVATION_DAMPING = 11275,
	RIGID_BODY_SB_SHAPE_CONSERVATION_DAMPING_MAP = 11276,
	RIGID_BODY_SB_SHAPE_CONSERVATION_ELASTIC_LIMIT = 11277,
	RIGID_BODY_SB_SHAPE_CONSERVATION_ELASTIC_LIMIT_MAP = 11278,

	RIGID_BODY_SB_PRESSURE_GROUP = 11280,

	RIGID_BODY_SB_PRESSURE = 11281,
	RIGID_BODY_SB_VOLUME_CONSERVATION = 11282,
	RIGID_BODY_SB_PRESSURE_DAMPING = 11283,

	RIGID_BODY_AERODYNAMICS_GROUP = 11290,

	RIGID_BODY_AERODYNAMICS_DRAG = 11292,
	RIGID_BODY_AERODYNAMICS_LIFT = 11293,
	RIGID_BODY_AERODYNAMICS_TWO_SIDED = 11294,

	RIGID_BODY_CACHE_LOCAL = 12291,
	RIGID_BODY_CACHE_USE = 12292,
	RIGID_BODY_CACHE_BAKE = 12293,
	RIGID_BODY_CACHE_CLEAR = 12294,
	RIGID_BODY_CACHE_BAKE_ALL = 12295,
	RIGID_BODY_CACHE_CLEAR_ALL = 12296,
	RIGID_BODY_CACHE_INCLUDE_COLLISIONS = 12297,
	RIGID_BODY_CACHE_MEMORY = 12299,

	RIGID_BODY_DUMMY
};

#endif
