#include "customgui_listview2.h"
#include "c4d_listview.h"

//////////////////////////////////////////////////////////////////////////

CustomGuiListViewLib *listview_library=NULL;

//////////////////////////////////////////////////////////////////////////

#define ListViewCall(b)       CustomGuiListViewLib *lib = CheckLib(LIBOFFSET(CustomGuiListViewLib, b)); \
															if (!lib || !lib->b) return; \
															(((iListViewData*)this)->*lib->b)

#define ListViewCallR(a,b)     CustomGuiListViewLib *lib = CheckLib(LIBOFFSET(CustomGuiListViewLib, b)); \
															if (!lib || !lib->b) return a; \
															return (((iListViewData*)this)->*lib->b)

static CustomGuiListViewLib *CheckLib(LONG offset)
{
	return (CustomGuiListViewLib*)CheckLib(CUSTOMGUI_LISTVIEW,offset,(C4DLibrary**)&listview_library);
}

ListViewData* ListViewData::Alloc() 
{
	CustomGuiListViewLib *lib = CheckLib(LIBOFFSET(CustomGuiListViewLib, Alloc));
	if (!lib || !lib->Alloc) return NULL;
	return (ListViewData*)lib->Alloc();
}

void ListViewData::Free(ListViewData *&pData)
{
	CustomGuiListViewLib *lib = CheckLib(LIBOFFSET(CustomGuiListViewLib, Free));
	if (!lib || !lib->Free) return;

	iListViewData *pLib=(iListViewData*)pData;
	lib->Free(pLib);
	pData=NULL;
}

Bool ListViewData::AddItem(LONG id, const String &name, const GeData &data) { ListViewCallR(FALSE,AddItem)(id,name,data); }
Bool ListViewData::UpdateItem(LONG id, const String &name, const GeData &data) { ListViewCallR(FALSE,UpdateItem)(id,name,data); }
void ListViewData::RemoveItem(LONG id) { ListViewCall(RemoveItem)(id); }
LONG ListViewData::GetSelected() { ListViewCallR(NOTOK,GetSelected)(); }
void ListViewData::Select(LONG index) { ListViewCall(Select)(index); }
GeData ListViewData::GetData(LONG index) { ListViewCallR(GeData(),GetData)(index); }
String ListViewData::GetName(LONG index) { ListViewCallR(String(),GetName)(index); }
LONG ListViewData::GetID(LONG index) { ListViewCallR(0,GetID)(index); }
LONG ListViewData::GetCount() { ListViewCallR(0,GetCount)(); }
void ListViewData::SetData(LONG index, const GeData &data) { ListViewCall(SetData)(index,data); }
void ListViewData::SetName(LONG index, const String &name) { ListViewCall(SetName)(index,name); }
void ListViewData::SetID(LONG index, LONG id) { ListViewCall(SetID)(index,id); }
LONG ListViewData::FindIndex(LONG id) { ListViewCallR(NOTOK,FindIndex)(id); }
