/////////////////////////////////////////////////////////////
// CINEMA 4D SDK                                           //
/////////////////////////////////////////////////////////////
// (c) MAXON Computer GmbH, all rights reserved            //
/////////////////////////////////////////////////////////////

#ifndef __C4D_OBJECTPLUGIN_H
#define __C4D_OBJECTPLUGIN_H

#include "ge_prepass.h"
#include "c4d_objectdata.h"
#include "c4d_nodeplugin.h"

struct OBJECTPLUGIN : public NODEPLUGIN
{
	BaseBitmap		*command_icon;

	void					(ObjectData::*GetDimension			)(BaseObject *op, Vector *mp, Vector *rad);
	DRAWRESULT		(ObjectData::*Draw							)(BaseObject *op, DRAWPASS drawpass, BaseDraw *bd, BaseDrawHelp *bh);
	LONG					(ObjectData::*DetectHandle			)(BaseObject *op, BaseDraw *bd, LONG x, LONG y, QUALIFIER qualifier);
	Bool					(ObjectData::*MoveHandleEx			)(BaseObject *op, BaseObject *undo, const Matrix &tm, LONG hit_id, QUALIFIER qualifier);

	// generator
	BaseObject*		(ObjectData::*GetVirtualObjects	)(BaseObject *op, HierarchyHelp *hh);

	// modifier
	Bool					(ObjectData::*ModifyObject			)(BaseObject *mod, BaseDocument *doc, BaseObject *op, const Matrix &op_mg, const Matrix &mod_mg, Real lod, LONG flags, BaseThread *thread);
	void					(ObjectData::*CheckDirty				)(BaseObject *op, BaseDocument *doc);
	
	// spline
	SplineObject* (ObjectData::*GetContour				)(BaseObject *op, BaseDocument *doc, Real lod, BaseThread *bt);

	// particle
	void					(ObjectData::*ModifyParticles		)(BaseObject *op, Particle *pp, BaseParticle *ss, LONG pcnt, Real diff);
	Bool					(ObjectData::*AddToExecution	  )(BaseObject *op, PriorityList *list);
	EXECUTIONRESULT	(ObjectData::*Execute					)(BaseObject *op, BaseDocument *doc, BaseThread *bt, LONG priority, EXECUTIONFLAGS flags);

	void					(ObjectData::*GetModelingAxis		)(BaseObject *op, BaseDocument *doc, Matrix &axis);
	Bool					(ObjectData::*MoveHandle				)(BaseObject *op, BaseObject *undo, const Vector &mouse_pos, LONG hit_id, QUALIFIER qualifier, BaseDraw *bd);
	
	DRAWRESULT		(ObjectData::*DrawShadow				)(BaseObject *op, BaseDraw *bd, BaseDrawHelp *bh);
	void*	reserved[(32-14)*C4DPL_MEMBERMULTIPLIER-1];
};

#endif
